function [glob,datevec]=dating_M2(bigvec,h,m,bigt)
% This is the main procedure which calculates the break points that globally 
% maximize the loglikelihood function. It returns optimal dates and associated 
% log likelihood for all numbers of breaks less than or equal to m. 

datevec                  = zeros(m,m);  
optdat                   = zeros(bigt,m); 
optlr                    = zeros(bigt,m);                    
dvec                     = zeros(bigt,1);                        
glob                     = zeros(m,1);

if m==1 
   [lrmax,datx]          = parti2(1,h,bigt-h,bigt,bigvec,bigt);
   datevec(1,1)          = datx;
   glob(1,1)             = lrmax;
else
   for j1=2*h:bigt                                                                       
    [lrmax,datx]         = parti2(1,h,j1-h,j1,bigvec(1:2*bigt),bigt);    
    optlr(j1,1)          = lrmax;     
    optdat(j1,1)         = datx;
   end
   glob(1,1)             = optlr(bigt,1);
   datevec(1,1)          = optdat(bigt,1);

   for ib=2:m
      if ib==m
        jlast            = bigt;
        for jb=ib*h:jlast-h
         dvec(jb,1)      = optlr(jb,ib-1)-0.5*(bigt-jb+1)*((log(2*pi)+1)+log(sum(bigvec(m*bigt+jb+1:bigt*(m+1)))/(bigt-jb)));
        end
        optlr(jlast,ib)  = max(dvec(ib*h:jlast-h,1));
        optdat(jlast,ib) = (ib*h-1)+maxindc(dvec(ib*h:jlast-h,1));
      else
        for jlast=(ib+1)*h:bigt
         for jb=ib*h:jlast-h
          dvec(jb,1)     = optlr(jb,ib-1)-0.5*(jlast-jb+1)*((log(2*pi)+1)+log(sum(bigvec(ib*bigt+jb+1:ib*bigt+jlast))/(jlast-jb)));
         end
         optlr(jlast,ib) = max(dvec(ib*h:jlast-h,1));
         optdat(jlast,ib) = (ib*h-1)+maxindc(dvec(ib*h:jlast-h,1));
        end
      end

      datevec(ib,ib)      = optdat(bigt,ib);
      for i=1:ib-1
        xx                = ib-i;
        datevec(xx,ib)    = optdat(datevec(xx+1,ib),xx);
      end
     glob(ib,1)           = optlr(bigt,ib);
   end
end  