function [brk,beta,brc,brv,res]=estdate(y,z,q,x,p,K,bigt,h,m,n,cbrind,vbrind)

% procedure to jointly estimates the coefficient and variance break dates
% following section 5.1 of Qu and Perron (2007). The code follows est.m of
% Qu and Perron (2007)

% step 1
[~,datevec,~]       = dating_MLE(y,z,q,x,p,h,K,bigt);
brk                 = datevec(:,K); 

% step 2
[brc,brv,R]         = segmake(K,brk,m,n,cbrind,vbrind,q);
[beta,res]          = estimbr(y,z,q,x,p,bigt,K,brk,R,n,brv,1);
if p>=1
y                   = y-x*invpd(x'*x)*x'*y;
z                   = z-x*invpd(x'*x)*x'*z;
end

% step 3-5
diff                = 0;
maxiter             = 10;
while diff~=-1 && diff<maxiter
    bigvec          = residuals(y,z,beta,q,K);
    [~,datevec]     = dating_M2(bigvec,h,K,bigt);
    if datevec(:,K)==brk
        diff        = -1;
    else
        brk         = datevec(:,K);
        [brc,brv,R] = segmake(K,brk,m,n,cbrind,vbrind,q);
        [beta,res]  = estimbr(y,z,q,x,p,bigt,K,brk,R,n,brv,1);
        diff        = diff+1;
    end
    if diff==maxiter
        disp('cannot find the converging break dates');
    end
end
