function [nbeta,res]=estimbr(y,z,q,x,p,bigt,K,brk,R,n,brv,rest)

% procedure to estimate coefficients and residuals by FGLS given break
% dates in coefficients and variance.
if p>=1
   y       = y-x*invpd(x'*x)*x'*y;
   z       = z-x*invpd(x'*x)*x'*z;
end

if K==0
   zbar    = z;
else
   zbar    = pzbar(z,K,brk);
end
if rest==1
zbar       = zbar*R;
end
beta0      = invpd(zbar'*zbar)*zbar'*y;
res0       = y-zbar*beta0;

ibigv      = eye(bigt);
vseg       = [0;brv;bigt];
for k=1:n+1
    i      = vseg(k)+1;
    j      = vseg(k+1);
    vvar   = res0(i:j,:)'*res0(i:j,:)/(j-i+1);
    ibigv(i:j,i:j)=eye(j-i+1)*invpd(vvar);
end
beta       = invpd(zbar'*ibigv*zbar)*zbar'*ibigv*y;

bstar      = beta+10;
itr        = 1;
while max(abs(bstar-beta))>=1e-6 && itr<=100
  bstar    = beta;
  res      = y-zbar*beta;
  
  ibigv    = eye(bigt);
  for k=1:n+1
      i    = vseg(k)+1;
      j    = vseg(k+1);
      vvar = res(i:j,1)'*res(i:j,1)/(j-i+1);
      ibigv(i:j,i:j)=eye(j-i+1)*invpd(vvar);
  end
  beta     = invpd(zbar'*ibigv*zbar)*zbar'*ibigv*y;
  itr      = itr+1;
  if itr==100
      disp('The iteration has reached the upper limit');
  end
end

if rest==1
   nbeta   = R*beta;
else
   nbeta=beta;
end
res        = y-zbar*beta;
