function [suplr,brcstar]=pslr0(y,z,q,m,x,p,bigt,robust,prewhit,h,typekc)

%%% 1) log-likelihood function under the null
if p==0
  reg0             = z;
else
  reg0             = [z x];
end
res0               = y-reg0*invpd(reg0'*reg0)*reg0'*y;
vvar0              = res0'*res0/bigt;
lr0                = -(bigt/2)*(log(2*pi)+1+log(vvar0));

%%% 2) log-likelihood function under the alternative
if p==0
  [~,datevec]      = dating(y,z,h,m,q,bigt);
else
  [~,datevec]      = datingpart(y,z,x,h,m,p,q,bigt);
end
brc                = datevec(:,m);
zbar               = pzbar(z,m,brc);
if p==0
   reg1            = zbar;
else
   reg1            = [zbar x];
end
beta1              = invpd(reg1'*reg1)*reg1'*y;
res1               = y-reg1*beta1;
vvar1              = res1'*res1/bigt;
lr1                = -(bigt/2)*(log(2*pi)+1+log(vvar1));

if robust==0
 suplr              = 2*(lr1-lr0);
elseif robust==1 
 if p==0
   vmat0            = zeros(bigt,q);
   vmat1            = zeros(bigt,q);
   for i=1:q
    vmat0(:,i)      = reg0(:,i).*res0;
    vmat1(:,i)      = reg0(:,i).*res1;
   end
   hac              = correct1(vmat0,vmat1,prewhit,typekc);
   lambda           = plambda(brc,m,bigt);
   vdel             = bigt*invpd(reg1'*reg1)*kron(lambda,hac)*invpd(reg1'*reg1);
   delta1           = beta1; 
 else
   regm             = zbar-x*invpd(x'*x)*x'*zbar;  
   vmat0            = zeros(bigt,q*(m+1));
   vmat1            = zeros(bigt,q*(m+1));
   for i=1:q*(m+1)
    vmat0(:,i)      = regm(:,i).*res0;
    vmat1(:,i)      = regm(:,i).*res1;
   end
   hac              = correct1(vmat0,vmat1,prewhit,typekc);
   vdel             = bigt*invpd(regm'*regm)*hac*invpd(regm'*regm); 
   delta1           = beta1(1:(m+1)*q,1);
 end
 
 rsub               = zeros(m,m+1);
 for j=1:m
  rsub(j,j)         = -1;
  rsub(j,j+1)       = 1;
 end
 rmat               = kron(rsub,eye(q));

 fstar              = delta1'*rmat'*invpd(rmat*vdel*rmat')*rmat*delta1;
 suplr              = (bigt-(m+1)*q-p)*fstar/bigt;    
end

brcstar             = brc;
suplr               = suplr/m;