function [suplr,newd]=pslr10(y,z,q,m,n,x,p,bigt,vrobust,prewhit,h,typek)

%%% 1)break date estimation under the null
if p==0
    reg0               = z;
else
    reg0               = [z x];
end
res0                   = y-reg0*invpd(reg0'*reg0)*reg0'*y;
vvar0                  = res0'*res0/bigt;
tao0                   = (res0.^2/vvar0)-1;
lr0                    = -(bigt/2)*(log(2*pi)+1+log(vvar0));

brcase                 = numcase(m,n);
suplrx                 = zeros(brcase,1);
brctemp                = zeros(brcase,m);
brvtemp                = zeros(brcase,n);

for idx=1:brcase
 [K,cbrind,vbrind]     = brcvcase(m,n,idx);
 [~,~,brc,brv,res1]    = estdate(y,z,q,x,p,K,bigt,h,m,n,cbrind,vbrind);
 brctemp(idx,:)        = brc';
 brvtemp(idx,:)        = brv';

 [lr1,tao1]            = ploglik(res1,n,brv);   
 [lrv1]                = ploglik(res0,n,brv);   
    
 if vrobust==0
    phi                = tao0'*tao0/(bigt-1);
 elseif vrobust==1
    phi                = correct1(tao0,tao1,prewhit,typek);
 end
 suplrx(idx,1)         = 2*(lr1-lr0)-((phi-2)/phi)*2*(lrv1-lr0);
end

[~,maxind]             = max(suplrx);
brc0                   = brctemp(maxind,:)';
brv0                   = brvtemp(maxind,:)';

%%% 2) construct segment-wise LR tests
nseg                   = n+1;
lrtest                 = zeros(nseg,1);
dv                     = zeros(nseg+1,1);
dv(2:nseg,1)           = brv0;
dv(nseg+1,1)           = bigt;
ds                     = zeros(nseg,1);

for is=1:nseg
   lengthi             = dv(is+1,1)-dv(is,1);
   if lengthi>=2*h
      starti           = dv(is,1)+1;
      endi             = dv(is+1,1);
      segy             = y(starti:endi,1);
      segz             = z(starti:endi,:);
      if p==0
         segx          = [];
      else
         segx          = x(starti:endi,:);
      end
      
      indbrc           = (brc0>starti).*(brc0<endi);
      mi               = sum(indbrc);
      brci             = [];
      for j=1:m
          if indbrc(j,1)==1
             brci      = [brci;brc0(j,1)-dv(is,1)]; 
          end
      end
      
      if mi==0
          segzbar      = segz;
      else
          segzbar      = pzbar(segz,mi,brci);
      end
      if p==0
          segreg0      = segzbar;
      else
          segreg0      = [segzbar segx];
      end
      segbeta0         = invpd(segreg0'*segreg0)*segreg0'*segy;
      segres0          = segy-segreg0*segbeta0;
      segvvar0         = segres0'*segres0/lengthi;
      seglr0           = -(lengthi/2)*(log(2*pi)+1+log(segvvar0));
      segtao0          = (segres0.^2/segvvar0)-1;
      
      bigveci          = zeros(lengthi*2,1);
      for i=1:2
          bigveci((i-1)*lengthi+1:i*lengthi,1)=segres0.^2;
      end
      [~,dateveci]     = dating_M2(bigveci,h,1,lengthi);
      brvi             = dateveci(1,1);
      [~,segres1]      = estimbr(segy,segz,q,segx,p,lengthi,mi,brci,[],1,brvi,0);
      [seglr1,segtao1] = ploglik(segres1,1,brvi);

      % segment-wise LR test
      if vrobust==0
          segphi       = segtao0'*segtao0/(lengthi-1);
      elseif vrobust==1
          segphi       = correct1(segtao0,segtao1,prewhit,typek);
      end
      
      lrtest(is,1)     = (2/segphi)*2*(seglr1-seglr0);
      ds(is,1)         = dv(is,1)+brvi;
   else
       lrtest(is,1)    = 0.0;
   end
    
   [suplr,news]        = max(lrtest);
   newd                = ds(news,1);
    
end
