function [suplr,brcstar,brvstar]=pslr3sub(y,z,q,m,n,x,p,bigt,robust,prewhit,h,typek)

%%% 1)log-likelihood function under the null
if p==0
    reg0            = z;
else
    reg0            = [z x];
end
res0                = y-reg0*invpd(reg0'*reg0)*reg0'*y;
bigvec              = zeros(bigt*(n+1),1);
for i=1:n+1
    bigvec((i-1)*bigt+1:i*bigt)=res0.^2;
end
[~,datevec]         = dating_M2(bigvec,h,n,bigt);
 brv                = datevec(:,n);
[~,brv,R]           = segmake(n,brv,0,n,zeros(n,1),ones(n,1),size(z,2));
[~,res0]            = estimbr(y,z,q,x,p,bigt,n,brv,R,n,brv,1);
lr0                 = ploglik(res0,n,brv);

%%% 2) log-likelihood function under the alternative
brcase              = numcase(m,n);
suplrx              = zeros(brcase,1);
brcdt               = zeros(brcase,m);
brvdt               = zeros(brcase,n);

for idx=1:brcase
 [K,cbrind,vbrind]  = brcvcase(m,n,idx);
 [~,~,brc,brv,res1] = estdate(y,z,q,x,p,K,bigt,h,m,n,cbrind,vbrind);
 brcdt(idx,:)       = brc';
 brvdt(idx,:)       = brv';
 [lr1,~]            = ploglik(res1,n,brv);   
 suplrx(idx,1)      = 2*(lr1-lr0);
end
[suplr,maxind]     = max(suplrx);
brcstar            = brcdt(maxind,:)';
brvstar            = brvdt(maxind,:)';

if robust==1
 zbar               = pzbar(z,m,brcstar);
 if p==0
    reg1            = zbar;
 else
    reg1            = [zbar x];
 end
 
 ibigv              = eye(bigt);
 vseg               = [0;brvstar;bigt];
 for k=1:n+1
    i               = vseg(k)+1;
    j               = vseg(k+1);
    vvar            = res1(i:j,:)'*res1(i:j,:)/(j-i+1);
    ibigv(i:j,i:j)  = eye(j-i+1)*invpd(vvar);
 end
 ys                 = ibigv^(1/2)*y;
 zbars              = ibigv^(1/2)*zbar;
 reg0s              = ibigv^(1/2)*reg0;
 reg1s              = ibigv^(1/2)*reg1;
 
 beta1s             = invpd(reg1s'*reg1s)*reg1s'*ys;
 res0s              = y-reg0*invpd(reg0s'*reg0s)*reg0s'*ys;
 res1s              = y-reg1*invpd(reg1s'*reg1s)*reg1s'*ys;

 if p==0
   vmat0            = zeros(bigt,q);
   vmat1            = zeros(bigt,q);
   for i=1:q
    vmat0(:,i)      = reg0(:,i).*res0s;
    vmat1(:,i)      = reg0(:,i).*res1s;
   end
   hac              = correct1(vmat0,vmat1,prewhit,typek);
   lambda           = plambda(brcstar,m,bigt);
   vdel             = bigt*invpd(reg1'*reg1)*kron(lambda,hac)*invpd(reg1'*reg1);
   delta1s          = beta1s; 
 else
   xs               = ibigv^(1/2)*x;  
   regms            = zbars-xs*invpd(xs'*xs)*xs'*zbars;  
   vmat0            = zeros(bigt,q*(m+1));
   vmat1            = zeros(bigt,q*(m+1));
   for i=1:q*(m+1)
    vmat0(:,i)      = regms(:,i).*res0s; 
    vmat1(:,i)      = regms(:,i).*res1s; 
   end
   hac              = correct1(vmat0,vmat1,prewhit,typek);
   vdel             = bigt*invpd(regms'*regms)*hac*invpd(regms'*regms); 
   delta1s          = beta1s(1:(m+1)*q,1);
 end
 
 rsub               = zeros(m,m+1);
 for j=1:m
  rsub(j,j)         = -1;
  rsub(j,j+1)       = 1;
 end
 rmat               = kron(rsub,eye(q));
 
 fstar              = delta1s'*rmat'*invpd(rmat*vdel*rmat')*rmat*delta1s;
 suplr              = (bigt-(m+1)*q-p)*fstar/bigt;    
end 

suplr               = suplr/m;