function [suplr,brcstar,brvstar]=pslr4(y,z,q,m,n,x,p,bigt,robust,vrobust,prewhit,h,typekbv,typekbc)

%%% 1) log-likelihood function under the null
if p==0
  reg0               = z;
else
  reg0               = [z x];
end
res0                 = y-reg0*invpd(reg0'*reg0)*reg0'*y;
vvar0                = res0'*res0/bigt;
tao0                 = (res0.^2/vvar0)-1;
lr0                  = -(bigt/2)*(log(2*pi)+1+log(vvar0));

%%% 2)log-likelihood function under the alternative
brcase               = numcase(m,n);
suplrx               = zeros(brcase,1);
suplrv               = zeros(brcase,1);
brcdt                = zeros(brcase,m);
brvdt                = zeros(brcase,n);

for idx=1:brcase
  [K,cbrind,vbrind]  = brcvcase(m,n,idx);
  [~,~,brc,brv,res1] = estdate(y,z,q,x,p,K,bigt,h,m,n,cbrind,vbrind);
  [lr1,tao1]         = ploglik(res1,n,brv);   
     
  %%% variance part
  zbar               = pzbar(z,m,brc);
  if p==0
     reg1            = zbar;
  else
     reg1            = [zbar x];
  end
  resv               = y-reg1*invpd(reg1'*reg1)*reg1'*y;
  vvarv              = resv'*resv/bigt;
  lrv0               = -(bigt/2)*(log(2*pi)+1+log(vvarv));
  lrv1               = ploglik(resv,n,brv);    
  if vrobust==0
     phi             = tao0'*tao0/(bigt-1);
  elseif vrobust==1
     phi             = correct1(tao0,tao1,prewhit,typekbv);
  end
  suplrx(idx,1)      = 2*(lr1-lr0)-((phi-2)/phi)*2*(lrv1-lrv0);
  suplrv(idx,1)      = (2/phi)*2*(lrv1-lrv0);
  brcdt(idx,:)       = brc';
  brvdt(idx,:)       = brv';
end
[suplr,maxind]       = max(suplrx);
suplrvar             = suplrv(maxind,1);
brcstar              = brcdt(maxind,:)';
brvstar              = brvdt(maxind,:)';

if robust==1
 zbar                = pzbar(z,m,brcstar);    
 if p==0
    reg1             = zbar;
 else
    reg1             = [zbar x];
 end
    
 ibigv               = eye(bigt);
 vseg                = [0;brvstar;bigt];
 for k=1:n+1
  i                  = vseg(k)+1;
  j                  = vseg(k+1);
  vvar               = res1(i:j,:)'*res1(i:j,:)/(j-i+1);
  ibigv(i:j,i:j)     = eye(j-i+1)*invpd(vvar);
 end
 ys                  = ibigv^(1/2)*y;
 zbars               = ibigv^(1/2)*zbar;
 reg0s               = ibigv^(1/2)*reg0;
 reg1s               = ibigv^(1/2)*reg1;
 
 beta1s              = invpd(reg1s'*reg1s)*reg1s'*ys;
 res0s               = ys-reg0s*invpd(reg0s'*reg0s)*reg0s'*ys;
 res1s               = ys-reg1s*invpd(reg1s'*reg1s)*reg1s'*ys;    
    
 if p==0
   vmat0             = zeros(bigt,q);
   vmat1             = zeros(bigt,q);
   for i=1:q
    vmat0(:,i)       = reg0s(:,i).*res0s;
    vmat1(:,i)       = reg0s(:,i).*res1s;
   end
   hac               = correct1(vmat0,vmat1,prewhit,typekbc);
   lambda            = plambda(brcstar,m,bigt);
   vdel              = bigt*invpd(reg1s'*reg1s)*kron(lambda,hac)*invpd(reg1s'*reg1s);
   delta1s           = beta1s; 
 else
   xs                = ibigv^(1/2)*x;  
   regms             = zbars-xs*invpd(xs'*xs)*xs'*zbars;  
   vmat0             = zeros(bigt,q*(m+1));
   vmat1             = zeros(bigt,q*(m+1));
   for i=1:q*(m+1)
    vmat0(:,i)       = regms(:,i).*res0s;
    vmat1(:,i)       = regms(:,i).*res1s;
   end
   hac               = correct1(vmat0,vmat1,prewhit,typekbc);
   vdel              = bigt*invpd(regms'*regms)*hac*invpd(regms'*regms); 
   delta1s           = beta1s(1:(m+1)*q,1);
 end
 
 rsub                = zeros(m,m+1);
 for j=1:m
  rsub(j,j)          = -1;
  rsub(j,j+1)        = 1;
 end
 rmat                = kron(rsub,eye(q));
 
 fstar               = delta1s'*rmat'*invpd(rmat*vdel*rmat')*rmat*delta1s;
 suplrcoef           = (bigt-(m+1)*q-p)*fstar/bigt;      
 suplr               = suplrcoef+suplrvar;
end

suplr                = suplr/(n+m);
