function [suplr,newd]=pslr9(y,z,q,m,n,x,p,bigt,robust,prewhit,h,typek)

%%% 1)break date estimation under the null
if p==0
    reg0               = z;
else
    reg0               = [z x];
end
res0                   = y-reg0*invpd(reg0'*reg0)*reg0'*y;
vvar0                  = res0'*res0/bigt;
tao0                   = (res0.^2/vvar0)-1;
lr0                    = -(bigt/2)*(log(2*pi)+1+log(vvar0));

brcase                 = numcase(m,n);
suplrx                 = zeros(brcase,1);
brctemp                = zeros(brcase,m);
brvtemp                = zeros(brcase,n);

for idx=1:brcase
 [K,cbrind,vbrind]     = brcvcase(m,n,idx);
 [~,~,brc,brv,res1]    = estdate(y,z,q,x,p,K,bigt,h,m,n,cbrind,vbrind);
 brctemp(idx,:)        = brc';
 brvtemp(idx,:)        = brv';

 [lr1,tao1]            = ploglik(res1,n,brv);   
 [lrv1]                = ploglik(res0,n,brv);   
    
 if robust==0
    phi                = tao0'*tao0/(bigt-1);
 elseif robust==1
    phi                = correct1(tao0,tao1,prewhit,typek);
 end
 suplrx(idx,1)         = 2*(lr1-lr0)-((phi-2)/phi)*2*(lrv1-lr0);
end

[~,maxind]             = max(suplrx);
brc0                   = brctemp(maxind,:)';
brv0                   = brvtemp(maxind,:)';
if size(brc0,1)==0
  zbar                 = z;
else
  zbar                 = pzbar(z,size(brc0,1),brc0);
end
if p==0
  reg1                 = zbar;
else
  reg1                 = [zbar x];
end
res1                   = y-reg1*invpd(reg1'*reg1)*reg1'*y;

%%% 2) construct segment-wise LR tests
nseg                   = m+1;
lrtest                 = zeros(nseg,1);
dv                     = zeros(nseg+1,1);
dv(2:nseg,1)           = brc0;
dv(nseg+1,1)           = bigt;
ds                     = zeros(nseg,1);

vseg                   = [0;brv0;bigt];
ys                     = zeros(size(y));
zs                     = zeros(size(z));
if p>=1
xs                     = zeros(size(x));
end
for k=1:n+1
   i                   = vseg(k)+1;
   j                   = vseg(k+1);
   vvar                = res1(i:j,1)'*res1(i:j,1)/(j-i+1);
   ys(i:j,:)           = y(i:j,:)./sqrt(vvar);
   zs(i:j,:)           = z(i:j,:)./sqrt(vvar);
   if p>=1
   xs(i:j,:)           = x(i:j,:)./sqrt(vvar);
   end
end
for is=1:nseg
   lengthi             = dv(is+1,1)-dv(is,1);
   if lengthi>=2*h
      starti           = dv(is,1)+1;
      endi             = dv(is+1,1);
      segy             = y(starti:endi,1);
      segz             = z(starti:endi,:);
      segys            = ys(starti:endi,1);
      segzs            = zs(starti:endi,:);
      if p==0
          segx         = [];
          segxs        = [];
          segreg       = segz;
          segregs      = segzs;          
      else
          segx         = x(starti:endi,:);
          segxs        = xs(starti:endi,:);
          segreg       = [segz segx];
          segregs      = [segzs segxs];
      end          
      
      indbrv           = (brv0>starti).*(brv0<endi);
      ni               = sum(indbrv);
      brvi             = [];
      for j=1:n
          if indbrv(j,1)==1
             brvi      = [brvi;brv0(j,1)-dv(is,1)]; 
          end
      end
      segres0          = segy-segreg*invpd(segregs'*segregs)*segregs'*segys;
      seglr0           = ploglik(segres0,ni,brvi);
      
      if p==0
      [~,dateveci]     = dating(segys,segzs,h,1,q,lengthi);
      else
      [~,dateveci]     = datingpart(segys,segzs,segxs,h,1,p,q,lengthi);  
      end            
      brci             = dateveci(1,1);
      [~,segres1]      = estimbr(segy,segz,q,segx,p,lengthi,1,brci,[],ni,brvi,0);
      
      if robust==0
        seglr1         = ploglik(segres1,ni,brvi);
        lrtest(is,1)   = 2*(seglr1-seglr0);
        ds(is,1)       = dv(is,1)+brci;      
      elseif robust==1
        segzbar        = pzbar(segz,1,brci);          
        segzbars       = pzbar(segzs,1,brci);
        if p==0
          segreg1      = segzbar;
          segreg0      = segz; 
          segreg1s     = segzbars;
          segreg0s     = segzs;
        else
          segreg1      = [segzbar segx];
          segreg0      = [segz segx];         
          segreg1s     = [segzbars segxs];
          segreg0s     = [segzs segxs];
        end
        beta1s         = invpd(segreg1s'*segreg1s)*segreg1s'*segys;
        segres0s       = segy-segreg0*invpd(segreg0s'*segreg0s)*segreg0s'*segys;
        segres1s       = segy-segreg1*invpd(segreg1s'*segreg1s)*segreg1s'*segys;
      
        if p==0
          vmat0        = zeros(lengthi,q);
          vmat1        = zeros(lengthi,q);
          for i=1:q
            vmat0(:,i) = segreg0(:,i).*segres0s;
            vmat1(:,i) = segreg0(:,i).*segres1s;
          end
          hac          = correct1(vmat0,vmat1,prewhit,typek);
          lambda       = plambda(brci,1,lengthi);
          vdel         = lengthi*invpd(segreg1'*segreg1)*kron(lambda,hac)*invpd(segreg1'*segreg1);
          delta1s      = beta1s;
        else
          segregms     = segzbars-segxs*invpd(segxs'*segxs)*segxs'*segys;
          vmat0        = zeros(lengthi,q*2);
          vmat1        = zeros(lengthi,q*2);
          for i=1:q*2
            vmat0(:,i) = segregms(:,i).*segres0s;
            vmat1(:,i) = segregms(:,i).*segres1s;
          end
          hac          = correct1(vmat0,vmat1,prewhit,typek);
          vdel         = lengthi*invpd(segregms'*segregms)*hac*invpd(segregms'*segregms);
          delta1s      = beta1s(1:q*2,1);      
        end
      
        rsub           = zeros(1,2);
        rsub(1,1)      = -1;
        rsub(1,2)      = 1;
        rmat           = kron(rsub,eye(q));
      
        fstari         = delta1s'*rmat'*invpd(rmat*vdel*rmat')*rmat*delta1s;
        lrtest(is,1)   = (lengthi-2*q-p)*fstari/lengthi;
      end      
   else
       lrtest(is,1)    = 0.0;
   end
    
   [suplr,news]        = max(lrtest);
   newd                = ds(news,1);         
end